#define ErroListaVazia -1
#define ErroListaCheia -2

typedef struct lista
{
    char soldado[50];
    lista *prox;
} Lista;

//criao de uma lista vazia
Lista *criaLista()
{
    return NULL;
}

/* insero no incio: retorna a lista atualizada */
Lista *insereLista (Lista *l, char nome[50])
{
    Lista *aux;
    Lista *novo = (Lista*) malloc(sizeof(Lista));
    strcpy(novo->soldado, nome);
    if(l==NULL)
    {
        printf("\nPrimeiro soldado");
        novo->prox = novo;
    }
    else
    {
        novo->prox = l;
        aux=l;
        do
        {
            aux=aux->prox;
        }
        while(aux->prox!=l);
        aux->prox=novo;
    }
    return novo;
}

/* funo imprime: imprime valores dos elementos */
void imprimeLista (Lista *l)
{
    Lista *p=l;
    if(p)
    {
        printf("\nImpressao da lista: \n");
        do
        {
            printf("Nome do soldado = %s\n", p->soldado);
            p=p->prox;
        }
        while (p!=l);
        printf("======================= fim da lista");
    }
    else
    {
        printf("Nenhum soldado cadastrado!\n");
    }
}
/* funo vazia: retorna 1 se vazia ou 0 se no vazia */
int ListaVazia (Lista *l)
{
    return (l == NULL);
}


void liberaLista (Lista *l)
{
    Lista *p = l, *t;
    while (p != l)
    {
        t = p->prox; /* guarda referncia p/ prx. elemento */
        free(p); /* libera a memria apontada por p */
        p = t; /* faz p apontar para o prximo */
    }
}

void sortear(Lista *l)
{
    int a,sorteio;
    if(l)
    {
        Lista *aux;
        sorteio=rand() % 800 + 200;
        printf("\nNumero sorteado: %d",sorteio);
        aux=l;
        for(a=0; a<sorteio; a++)
            aux=aux->prox;
        printf("\nO soldado contenplado foi: %s",aux->soldado);
    }
    else
        printf("Precisa inserir um soldado antes pelo menos\n");
}
